VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents mForm As cWidgetForm
Attribute mForm.VB_VarHelpID = -1
Private WithEvents MenuBar As cwMenuBar
Attribute MenuBar.VB_VarHelpID = -1
Private WithEvents PopUpMenu As cwMenu
Attribute PopUpMenu.VB_VarHelpID = -1

Private WithEvents ddl As cwDropDownList
Attribute ddl.VB_VarHelpID = -1

Private Const FORM_WIDTH As Single = 420
Private Const FORM_HEIGHT As Single = 580

Public Sub Show()
Dim display As cDisplay, displays As cDisplays

    Set displays = New_c.displays
    For Each display In displays
        If display.IsPrimary Then Exit For
    Next
    With mForm
        If Not display Is Nothing Then _
            .CenterOn display
        .Show
    End With

End Sub

Private Sub Class_Initialize()
    Set mForm = Cairo.WidgetForms.Create( _
        vbSizable, "Kontakte", , FORM_WIDTH, FORM_HEIGHT)
End Sub

Private Sub Class_Terminate()
    mForm.Unload
End Sub

Private Sub ddlBundeslaender_Click()
    Debug.Print ddl.DataSource.FieldValue(0)
    Debug.Print ddl.DataSource.FieldValue(1)
End Sub

Private Sub MenuBar_Click(ByVal CurMenuItemPath As String)
Dim i As Integer
    Select Case True
        Case CurMenuItemPath = "mnuDatei>mnuBeenden"
            mForm.Unload
        Case Left$(CurMenuItemPath, 15) = "mnuAnsicht>Zoom"
            With MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Zoom")
                For i = 1 To .SubItemCount
                    MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Zoom>mnuZoom" & i).Checked = False
                Next i
            End With
            MenuBar.DataSource.SubItemByPathKey(CurMenuItemPath).Checked = True
            With mForm
                If CurMenuItemPath = "mnuAnsicht>Zoom>mnuZoom2" Then
                    .WidgetRoot.Zoom = 1.25
                ElseIf CurMenuItemPath = "mnuAnsicht>Zoom>mnuZoom3" Then
                    .WidgetRoot.Zoom = 1.5
                Else
                    .WidgetRoot.Zoom = 1
                End If
                .Width = FORM_WIDTH * .WidgetRoot.Zoom
                .Height = FORM_HEIGHT * .WidgetRoot.Zoom
                .CenterOn .WidgetRoot.CurrentMonitor
            End With
    End Select
End Sub

Private Sub mForm_BubblingEvent(Sender As Object, EventName As String, P1 As Variant, P2 As Variant, P3 As Variant, P4 As Variant, P5 As Variant, P6 As Variant, P7 As Variant)
Dim W As cWidgetBase
    Set W = Sender.Widget
    Select Case EventName
        Case "W_GotFocus"
            If W.Key = "fraKategorie" Then mForm.Widgets("optInteressent").Widget.SetFocus
        Case "W_Click"
            If W.Key = "btnAbbrechen" Then mForm.Unload
        Case "W_MouseDown"
            If P1 <> vbRightButton Then Exit Sub
            If TypeOf Sender Is cwTextBox Then
                PopUpMenu.InitAndShow W, CreatePopUpForTextBox(Sender), PopupBehaviourMousePosExpandRight
            End If
    End Select

End Sub

Private Sub mForm_Load()
Dim lbl As cwLabel
Dim txt As cwTextBox
Dim btn As cwButton
Dim fra As cwFrame
Dim bundeslaender As cCollection


    Set bundeslaender = New_c.Collection()
    With bundeslaender
        .Add "BW", "Baden-Wrttemberg"
        .Add "BY", "Bayern"
        .Add "BE", "Berlin"
        .Add "BB", "Brandenburg"
        .Add "HB", "Bremen"
        .Add "HH", "Hamburg"
        .Add "HE", "Hessen"
        .Add "MV", "Mecklenburg-Vorpommern"
        .Add "NI", "Niedersachsen"
        .Add "NW", "Nordrhein-Westfalen"
        .Add "RP", "Rheinland-Pfalz"
        .Add "SL", "Saarland"
        .Add "SN", "Sachsen"
        .Add "ST", "Sachsen-Anhalt"
        .Add "SH", "Schleswig-Holstein"
        .Add "TH", "Thringen"
    End With
    
    Set MenuBar = mForm.Widgets.Add( _
        New cwMenuBar, "MenuBar", 0, 0, mForm.ScaleWidth, 25)
    Set MenuBar.DataSource = Cairo.CreateMenuItemFromJSON(MainMenuAsJSONString)

    With New cFormRaster
        .CreateRaster Left:=10, Top:=30, _
                      Rows:=15, Cols:=32, _
                      RowHeight:=40, ColWidth:=10
                      
        mForm.Widgets.Add(New_w("cwFrame"), "fraKategorie", _
            .X(1), .Y(1), 390, 50).Caption = "Kategorie"
            
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optInteressent", _
            .X(2), .Y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "&Interessent"
            btn.Value = True
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optKunde", _
            .X(12), .Y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "&Kunde"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optLieferant", _
            .X(22), .Y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "&Lieferant"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optPrivat", _
            .X(32), .Y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "&Privat"
            
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblName", _
            .X(1), .Y(3), 100, 23)
            lbl.Caption = "&Name:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtName", _
            .X(20), .Y(3), 200, 23).MaxLength = 50
        
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblVorname", _
            .X(1), .Y(4), 100, 23)
            lbl.Caption = "&Vorname:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtVorname", _
            .X(20), .Y(4), 200, 23).MaxLength = 50
        
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblStrasse", _
            .X(1), .Y(5), 100, 23)
            lbl.Caption = "&Strae:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtStrae", _
            .X(20), .Y(5), 200, 23).MaxLength = 50
        
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblPlz", _
            .X(1), .Y(6), 100, 23)
            lbl.Caption = "PL&Z:"
            lbl.BorderWidth = 0
        Set txt = mForm.Widgets.Add(New_w("cwTextBox"), "txtPLZ", _
            .X(20), .Y(6), 50, 23)
            txt.MaxLength = 5
            txt.Filter = cfpNumber
        
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblOrt", _
            .X(1), .Y(7), 100, 23)
            lbl.Caption = "&Ort:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtOrt", _
            .X(20), .Y(7), 200, 23).MaxLength = 30
    
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblBundesland", _
            .X(1), .Y(8), 100, 23)
            lbl.Caption = "&Bundesland:"
            lbl.BorderWidth = 0
        Set ddl = mForm.Widgets.Add(New_w("cwDropDownList"), "ddlBundesland", _
            .X(20), .Y(8), 200, 23)
            ddl.SetDataSource bundeslaender, "Bundeslnder"
            ddl.DataSource.Sort = "Key Asc"
        
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "chkAktiv", _
            .X(20), .Y(9), 200, 23)
            btn.ButtonStyle = CheckBox
            btn.Caption = "Aktiv"
        
        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblBemerkungen", _
            .X(1), .Y(10) - 23, 100, 23)
            lbl.Caption = "B&emerkungen:"
            lbl.BorderWidth = 0
        Set txt = mForm.Widgets.Add(New_w("cwTextBox"), "txtBemerkungen", _
            .X(1), .Y(10), 390, 100)
            txt.MaxLength = 512
            txt.MultiLine = True
            txt.ScrollBars = vbVertical
        
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "btnAbbrechen", _
            .X(20), .Y(13), 90, 23)
            btn.Caption = "Abbrechen"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "btnSpeichern", _
            .X(31), .Y(13), 90, 23)
            btn.Caption = "Speichern"

    End With
    
    Set PopUpMenu = New_w("cwMenu")
    
End Sub

Private Function MainMenuAsJSONString() As String
  With Cairo.CreateMenuItemRoot("menuBarMain", "")
    With .AddSubItem("mnuDatei", "&Datei")
        .AddSubItem "mnuBeenden", "&Beenden"
    End With
    With .AddSubItem("mnuAnsicht", "&Ansicht")
      With .AddSubItem("Zoom", "&Zoom")
          .AddSubItem "mnuZoom1", "100%", , , True
          .AddSubItem("mnuZoom2", "125%").IsCheckable = True
          .AddSubItem("mnuZoom3", "150%").IsCheckable = True
      End With
    End With
    With .AddSubItem("mnuHilfe", "&Hilfe")
      .AddSubItem "mnuHilfeInhalt", "&Inhalt"
      .AddSubItem "mnuHilfeIndex", "Inde&x"
      .AddSubItem "mnuHilfeSuche", "&Suche"
      .AddSubItem "mnuHilfeSep", "-"
      .AddSubItem "mnuHilfeInfo", "Inf&o..."
    End With
    MainMenuAsJSONString = .ToJSONString
  End With
End Function

Private Sub PopUpMenu_Click(ByVal CurMenuItemPath As String)
Dim CurDSItem As cMenuItem
Dim txt As cwTextBox

    Set CurDSItem = PopUpMenu.DataSource.SubItemByPathKey(CurMenuItemPath)
    
    If InStr(CurMenuItemPath, "TxtBoxRoot") = 1 Then
      If TypeOf mForm.WidgetRoot.ActiveWidget.Object Is cwTextBox Then
        Set txt = mForm.WidgetRoot.ActiveWidget.Object
      Else
        Exit Sub
      End If
      Select Case CurDSItem.Key
        Case "puCut", "puCopy"
            New_c.Clipboard.SetText txt.SelText
            If CurDSItem.Key = "puCut" Then txt.SelText = ""
        Case "puPaste"
            txt.SelText = New_c.Clipboard.GetText
        Case "puDelete"
            txt.SelText = ""
        Case "puSelectAll"
            txt.SelStart = 0
            txt.SelLength = 10000000
      End Select
    End If
End Sub


